--------------------------------------------------------------------------------
-- Weapon Crowbar by Vectar666
-- Based on:
--
-- Weapon Pick
-- Original Carnage Contest Weapon
-- Script by DC, August 2009, www.UnrealSoftware.de
--------------------------------------------------------------------------------

-- Setup Tables
if cc==nil then cc={} end
if cc.hl2==nil then cc.hl2={} end
cc.hl2.crowbar={}

-- Load & Prepare Ressources
cc.hl2.crowbar.gfx_wpn=loadgfx("weapons/HL2_crowbar.bmp")							-- Weapon Image
setmidhandle(cc.hl2.crowbar.gfx_wpn)
cc.hl2.crowbar.sfx_attack=loadsfx("swish.ogg")								-- Attack Sound
cc.hl2.crowbar.sfx_hitground=loadsfx("hl2_crowbar_impact.wav")						-- Hit Ground Sound

--------------------------------------------------------------------------------
-- Weapon: Pick
--------------------------------------------------------------------------------

cc.hl2.crowbar.id=addweapon("cc.hl2.crowbar","Crowbar",cc.hl2.crowbar.gfx_wpn,10)				-- Add Weapon
cc.hl2.crowbar.ammo=5														-- 2 hits

function cc.hl2.crowbar.draw()												-- Draw
	-- Draw
	if getplayeraction(0)==0 then
		setblend(blend_alpha)
		setalpha(1)
		setcolor(255,255,255)
		setscale(-getplayerdirection(0),1)
		setrotation(getplayerrotation(0)-(30-(weapon_timer*3))*(getplayerdirection(0)))
		drawimage(cc.hl2.crowbar.gfx_wpn,getplayerx(0)+getplayerdirection(0)*7,getplayery(0)+3)
	end
	-- HUD ammobar
	if cc.hl2.crowbar.ammo-weapon_shots>0 then
		hudammobar(cc.hl2.crowbar.ammo-weapon_shots,cc.hl2.crowbar.ammo)
	end
	-- HUD Crosshair
	if cc.hl2.crowbar.ammo-weapon_shots>0 then
		hudcrosshair(7,3)
	end
end

function cc.hl2.crowbar.attack(attack)										-- Attack
	-- Timer
	if weapon_timer>0 then
		weapon_timer=weapon_timer-1
	end
	if (weapon_shots<cc.hl2.crowbar.ammo) and (weapon_timer<=0) then
		if (attack==1) then
			-- No more weapon switching!
			useweapon(0)
			playsound(cc.hl2.crowbar.sfx_attack)
			weapon_shots=weapon_shots+1
			weapon_timer=17
			-- Collision
			if collision(col20x20,getplayerx(0)+getplayerdirection(0)*21,getplayery(0),1,1)==1 then
				if playercollision()~=0 and playercollision()~=playercurrent() then
					playerpush(playercollision(),getplayerdirection(0)*2,-1)
					playerdamage(playercollision(),20)
					playsound(sfx_splatter1)
				end
				if terraincollision()==1 then
					playsound(cc.hl2.crowbar.sfx_hitground)
				end
			end
			-- Free Terrain
			terrainexplosion(getplayerx(0)+getplayerdirection(0)*7+math.sin(math.rad(getplayerrotation(0)))*1,getplayery(0)-1-math.cos(math.rad(getplayerrotation(0)))*3,10,2)
			terrainexplosion(getplayerx(0)+getplayerdirection(0)*7+math.sin(math.rad(getplayerrotation(0)))*10,getplayery(0)-1-math.cos(math.rad(getplayerrotation(0)))*10,10,2)
			-- End Turn
			if weapon_shots>=cc.hl2.crowbar.ammo then
				endturn()
			end
		end
	end
end
