--------------------------------------------------------------------------------
-- Half-life 2 SMG (MP7) weapon by Vectar666
-- Based on:
-- Weapon Pistol + Projectile Bullet
-- and
-- Weapon Mortar + Projectile Rocket
-- Original Carnage Contest Weapons
-- Script by DC, August 2009, www.UnrealSoftware.de
--------------------------------------------------------------------------------

-- Setup Tables
if cc==nil then cc={} end
if cc.hl2==nil then cc.hl2={} end
cc.hl2.SMG={}
cc.hl2.SMG.bullet={}
cc.hl2.SMG.grenade={}

-- Load & Prepare Ressources
cc.hl2.SMG.gfx_wpn=loadgfx("weapons/HL2_SMG.bmp")					-- Weapon Image
setmidhandle(cc.hl2.SMG.gfx_wpn)
cc.hl2.SMG.gfx_pro=loadgfx("weapons/shot.bmp")					-- Projectile Image
setmidhandle(cc.hl2.SMG.gfx_pro)
cc.hl2.SMG.gfx_grenade=loadgfx("weapons/HL2_SMG_grenade.bmp")
setmidhandle(cc.hl2.SMG.gfx_grenade)
cc.hl2.SMG.sfx_attack=loadsfx("HL2_SMG.wav")						-- Attack Sound
cc.hl2.SMG.sfx_grenade=loadsfx("HL2_SMG_grenade.wav")

--------------------------------------------------------------------------------
-- Weapon: Pistol
--------------------------------------------------------------------------------

cc.hl2.SMG.id=addweapon("cc.hl2.SMG","SMG",cc.hl2.SMG.gfx_wpn,1)	-- Add Weapon
cc.hl2.SMG.ammo=45												-- 45 Bullets

function cc.hl2.SMG.draw()										-- Draw
	setblend(blend_alpha)
	setalpha(1)
	setcolor(255,255,255)
	drawinhand(cc.hl2.SMG.gfx_wpn,6,0)
	-- HUD ammobar
	if cc.hl2.SMG.ammo-weapon_shots>0 then
		if weapon_timer==1 then
		hudammobar(cc.hl2.SMG.ammo-weapon_shots,cc.hl2.SMG.ammo)
		else
		hudammobar(2-weapon_shots,2)
		end
	end
	-- HUD Crosshair
	if cc.hl2.SMG.ammo-weapon_shots>0 then
		hudcrosshair(7,3)
		if weapon_mode==1 then
			hudtimer(1,1,1)
		elseif weapon_mode==2 then
			hudtimer(2,2,2)
		else
			hudtimer(1,1,2)
		end
	end
end

function cc.hl2.SMG.attack(attack)								-- Attack
	-- Decrement timer
	if cc.hl2.SMG.weapon_timer==nil then cc.hl2.SMG.weapon_timer=0 end
	if cc.hl2.SMG.weapon_timer>0 then
		cc.hl2.SMG.weapon_timer=cc.hl2.SMG.weapon_timer-1
	end
	-- Start burst
	if attack==1 then
		-- No more weapon switching!
		useweapon(0)
		weapon_mode=weapon_timer
	end
	-- Attack
	if weapon_shots<cc.hl2.SMG.ammo and cc.hl2.SMG.weapon_timer<=0 and weapon_mode==1 then
		-- Reset Timer
		cc.hl2.SMG.weapon_timer=4
		-- Attack
		playsound(cc.hl2.SMG.sfx_attack)
		weapon_shots=weapon_shots+1
		id=createprojectile(cc.hl2.SMG.bullet.id)
		projectiles[id]={}
		-- Ignore collision with current player at beginning
		projectiles[id].ignore=playercurrent()
		-- Set initial position of projectile
		projectiles[id].x=getplayerx(0)+(7*getplayerdirection(0))-math.sin(math.rad(getplayerrotation(0)))*5.0
		projectiles[id].y=getplayery(0)+3+math.cos(math.rad(getplayerrotation(0)))*5.0
		-- Set speed of projectile
		math.randomseed(weapon_shots*12345)
		offset=-2.0+math.random()*4.0
		projectiles[id].sx=math.sin(math.rad(getplayerrotation(0)+offset))*20.0
		projectiles[id].sy=-math.cos(math.rad(getplayerrotation(0)+offset))*20.0
		
		projectiles[id].timer=0
		-- Initial movement
		projectiles[id].x=projectiles[id].x-projectiles[id].sx*1
		projectiles[id].y=projectiles[id].y-projectiles[id].sy*1
		for i=1,3,1 do
			if cc.hl2.SMG.bullet.move(id)==1 then
				break
			end
		end
		-- Effects
		recoil(3)
		particle(p_muzzle,getplayerx(0)+(getplayerdirection(0)*7)+math.sin(math.rad(getplayerrotation(0)))*16,getplayery(0)+3-math.cos(math.rad(getplayerrotation(0)))*16)
		particle(p_smoke,getplayerx(0)+(getplayerdirection(0)*7)+math.sin(math.rad(getplayerrotation(0)))*16,getplayery(0)+3-math.cos(math.rad(getplayerrotation(0)))*16)
		particlespeed(-0.2+math.random()*0.4+getwind()*10.0,-1.0+math.random()*0.6)
		particlefadealpha(0.005)
		-- End Turn
		if (weapon_shots>=cc.hl2.SMG.ammo) then
			endturn()
		end
	end
	if	attack==1 and weapon_mode==2 and cc.hl2.SMG.weapon_timer<=0 and weapon_shots<2 then
		cc.hl2.SMG.weapon_timer=80
		weapon_shots=weapon_shots+1
		playsound(cc.hl2.SMG.sfx_grenade)
		id=createprojectile(cc.hl2.SMG.grenade.id)
		projectiles[id]={}
		-- Ignore collision with current player at beginning
		projectiles[id].ignore=playercurrent()
		-- Set initial position of projectile
		projectiles[id].x=getplayerx(0)+(6*getplayerdirection(0))+math.sin(math.rad(getplayerrotation(0)))*10.0
		projectiles[id].y=getplayery(0)+3-math.cos(math.rad(getplayerrotation(0)))*10.0
		-- Initial movement
		projectiles[id].sx=math.sin(math.rad(getplayerrotation(0)))*20
		projectiles[id].sy=-math.cos(math.rad(getplayerrotation(0)))*20
		projectiles[id].x=projectiles[id].x-projectiles[id].sx
		projectiles[id].y=projectiles[id].y-projectiles[id].sy
		cc.hl2.SMG.grenade.move(id)
		-- Set speed of projectile
		projectiles[id].sx=math.sin(math.rad(getplayerrotation(0)))*10.0
		projectiles[id].sy=-math.cos(math.rad(getplayerrotation(0)))*10.0
		-- Effects
		recoil(5)
		-- End Turn
		if (weapon_shots>=2) then
			endturn()
		end
	end
end

--------------------------------------------------------------------------------
-- Projectile: Bullet
--------------------------------------------------------------------------------

cc.hl2.SMG.bullet.id=addprojectile("cc.hl2.SMG.bullet")		-- Add Projectile

function cc.hl2.SMG.bullet.draw(id)							-- Draw
	-- Setup draw mode
	setblend(blend_light)
	setalpha(1)
	setcolor(255,255,0)
	setscale(1,1)
	-- Calculate projectile rotation
	setrotation(math.deg(math.atan2(projectiles[id].sx,-projectiles[id].sy)))
	-- Draw projectile
	drawimage(cc.hl2.SMG.gfx_pro,projectiles[id].x,projectiles[id].y)
	-- Draw Arrow if out of Screen
	outofscreenarrow(projectiles[id].x,projectiles[id].y)
end

function cc.hl2.SMG.bullet.update(id)						-- Update
	-- Wind + Gravity influence on speed
	projectiles[id].sx=projectiles[id].sx+getwind()*0.01
	projectiles[id].sy=projectiles[id].sy+getgravity()*0.1
	-- Move
	cc.hl2.SMG.bullet.move(id)
end

function cc.hl2.SMG.bullet.move(id)
	-- Timer (free after 10 secs)
	projectiles[id].timer=projectiles[id].timer+1
	if projectiles[id].timer>500 then
		-- Free projectile
		freeprojectile(id)
		return 1
	end
	rot=math.deg(math.atan2(projectiles[id].sx,-projectiles[id].sy))
	-- Move (in substep loop for optimal collision precision)
	msubt=math.ceil(math.max(math.abs(projectiles[id].sx),math.abs(projectiles[id].sy))/3)
	msubx=projectiles[id].sx/msubt
	msuby=projectiles[id].sy/msubt
	for i=1,msubt,1 do
		projectiles[id].x=projectiles[id].x+msubx
		projectiles[id].y=projectiles[id].y+msuby		
		-- Collision
		if collision(col3x3,projectiles[id].x+math.sin(math.rad(rot))*20,projectiles[id].y-math.cos(math.rad(rot))*20,1,1)==1 then
			if terraincollision()==1 or playercollision()~=projectiles[id].ignore then
				-- Cause damage
				if playercollision()~=0 and playercollision()~=playercurrent() then
					playerpush(playercollision(),projectiles[id].sx/10.0,projectiles[id].sy/10.0)
					playerdamage(playercollision(),4)
					blood(projectiles[id].x+math.sin(math.rad(rot))*20,projectiles[id].y-math.cos(math.rad(rot))*20)
				end
				-- Destroy terrain
				for j=20,22,1 do
					terraincircle(projectiles[id].x+math.sin(math.rad(rot))*j,projectiles[id].y-math.cos(math.rad(rot))*j,3,0x00000000)
				end
				-- Effects
				playsound(sfx_ricochet1)
				particle(p_smoke,projectiles[id].x+math.sin(math.rad(rot))*21,projectiles[id].y-math.cos(math.rad(rot))*21)
				particlefadealpha(0.006)
				particle(p_muzzle,projectiles[id].x+math.sin(math.rad(rot))*21,projectiles[id].y-math.cos(math.rad(rot))*21)
				-- Free projectile
				freeprojectile(id)
				return 1
			end
		else
			projectiles[id].ignore=0
		end
		-- Water
		if (projectiles[id].y)>getwatery()+5 then
			-- Effects
			particle(p_waterhit,projectiles[id].x,projectiles[id].y)
			if math.random(1,2)==1 then
				playsound(sfx_hitwater2)
			else
				playsound(sfx_hitwater3)
			end
			-- Free projectile
			freeprojectile(id)
			return 1
		end
	end
end

--------------------------------------------------------------------------------
-- Projectile: Rocket
--------------------------------------------------------------------------------

cc.hl2.SMG.grenade.id=addprojectile("cc.hl2.SMG.grenade")		-- Add Projectile

function cc.hl2.SMG.grenade.draw(id)							-- Draw
	-- Setup draw mode
	setblend(blend_alpha)
	setalpha(1)
	setcolor(255,255,255)
	setscale(1,1)
	-- Calculate projectile rotation
	setrotation(math.deg(math.atan2(projectiles[id].sx,-projectiles[id].sy)))
	-- Draw projectile
	drawimage(cc.hl2.SMG.gfx_grenade,projectiles[id].x,projectiles[id].y)
	-- Draw Arrow if out of Screen
	outofscreenarrow(projectiles[id].x,projectiles[id].y)
end

function cc.hl2.SMG.grenade.update(id)						-- Update
	-- Move
	cc.hl2.SMG.grenade.move(id)
end

function cc.hl2.SMG.grenade.move(id)
	rot=math.deg(math.atan2(projectiles[id].sx,-projectiles[id].sy))
	-- Wind + Gravity influence on speed
	projectiles[id].sx=projectiles[id].sx+getwind()*0.1
	projectiles[id].sy=projectiles[id].sy+getgravity()*1.5
	-- Move (in substep loop for optimal collision precision)
	msubt=math.ceil(math.max(math.abs(projectiles[id].sx),math.abs(projectiles[id].sy))/3)
	msubx=projectiles[id].sx/msubt
	msuby=projectiles[id].sy/msubt
	for i=1,msubt,1 do
		projectiles[id].x=projectiles[id].x+msubx
		projectiles[id].y=projectiles[id].y+msuby
		-- Collision
		if collision(col3x3,projectiles[id].x+math.sin(math.rad(rot))*3,projectiles[id].y-math.cos(math.rad(rot))*3,1,1)==1 then
			if terraincollision()==1 or playercollision()~=projectiles[id].ignore then
				-- Cause damage
				arealdamage(projectiles[id].x,projectiles[id].y,75,125)
				-- Destroy terrain
				terrainexplosion(projectiles[id].x,projectiles[id].y,25,1)
				-- Crater
				grey=math.random(0,40)
				if math.random(0,1)==1 then
					terrainalphaimage(gfx_crater50,projectiles[id].x,projectiles[id].y,math.random(6,9)*0.1,grey,grey,grey)
				else
					terrainalphaimage(gfx_crater75,projectiles[id].x,projectiles[id].y,math.random(6,9)*0.1,grey,grey,grey)
				end
				-- Free projectile
				freeprojectile(id)
				break
			end
		else
			projectiles[id].ignore=0
		end
		-- Water
		if (projectiles[id].y)>getwatery()+5 then
			-- Effects
			particle(p_waterhit,projectiles[id].x,projectiles[id].y)
			playsound(sfx_hitwater1)
			-- Free projectile
			freeprojectile(id)
			break
		end
	end
	-- Scroll to projectile
	scroll(projectiles[id].x,projectiles[id].y)
end