--------------------------------------------------------------------------------
-- Half-life 2 Shotgun weapon by Vectar666
-- Based on:
-- Weapon Pistol + Projectile Bullet
-- Original Carnage Contest Weapon
-- Script by DC, August 2009, www.UnrealSoftware.de
--------------------------------------------------------------------------------

-- Setup Tables
if cc==nil then cc={} end
if cc.hl2==nil then cc.hl2={} end
cc.hl2.Shotgun={}
cc.hl2.Shotgun.bullet={}

-- Load & Prepare Ressources
cc.hl2.Shotgun.gfx_wpn=loadgfx("weapons/HL2_Shotgun.bmp")					-- Weapon Image
setmidhandle(cc.hl2.Shotgun.gfx_wpn)
cc.hl2.Shotgun.gfx_pro=loadgfx("weapons/shot.bmp")					-- Projectile Image
setmidhandle(cc.hl2.Shotgun.gfx_pro)
cc.hl2.Shotgun.sfx_attack1=loadsfx("HL2_Shotgun_single.wav")
cc.hl2.Shotgun.sfx_attack2=loadsfx("HL2_Shotgun_double.wav")	
cc.hl2.Shotgun.sfx_cock=loadsfx("HL2_Shotgun_Cock.wav")					-- Attack Sound

--------------------------------------------------------------------------------
-- Weapon: Pistol
--------------------------------------------------------------------------------

cc.hl2.Shotgun.id=addweapon("cc.hl2.Shotgun","Shotgun",cc.hl2.Shotgun.gfx_wpn,1,2)	-- Add Weapon
cc.hl2.Shotgun.ammo=6												-- 18 Bullets

function cc.hl2.Shotgun.draw()										-- Draw
	setblend(blend_alpha)
	setalpha(1)
	setcolor(255,255,255)
	drawinhand(cc.hl2.Shotgun.gfx_wpn,6,0)
	-- HUD ammobar
	if cc.hl2.Shotgun.ammo-weapon_shots>0 then
		hudammobar(cc.hl2.Shotgun.ammo-weapon_shots,cc.hl2.Shotgun.ammo)
	end
	-- HUD Crosshair
	if cc.hl2.Shotgun.ammo-weapon_shots>0 then
		hudcrosshair(7,3)
		hudtimer(1,1,2)
	end
end

function cc.hl2.Shotgun.attack(attack)								-- Attack
	-- Decrement timer
	if cc.hl2.Shotgun.weapon_timer==nil then cc.hl2.Shotgun.weapon_timer=0 end
	if cc.hl2.Shotgun.weapon_timer>0 then
		cc.hl2.Shotgun.weapon_timer=cc.hl2.Shotgun.weapon_timer-1
	end
	-- Attack
	if cc.hl2.Shotgun.weapon_timer==30 and weapon_timer==1 or cc.hl2.Shotgun.weapon_timer==35 and weapon_timer==2 then playsound(cc.hl2.Shotgun.sfx_cock) end
		
	if weapon_shots<cc.hl2.Shotgun.ammo and cc.hl2.Shotgun.weapon_timer<=0 and attack==1 then
		-- No more weapon switching!
		useweapon(0)
		-- Reset Timer
		if(weapon_shots>4) then weapon_timer=1 end
		if(weapon_timer==1) then
			cc.hl2.Shotgun.weapon_timer=50
			shotgun_pellets=7
			playsound(cc.hl2.Shotgun.sfx_attack1)
		else
			cc.hl2.Shotgun.weapon_timer=65
			shotgun_pellets=12
			playsound(cc.hl2.Shotgun.sfx_attack2)
		end
		weapon_shots=weapon_shots+weapon_timer
		for j=1,shotgun_pellets,1 do
			id=createprojectile(cc.hl2.Shotgun.bullet.id)
			projectiles[id]={}
			-- Ignore collision with current player at beginning
			projectiles[id].ignore=playercurrent()
			-- Set initial position of projectile
			projectiles[id].x=getplayerx(0)+(7*getplayerdirection(0))-math.sin(math.rad(getplayerrotation(0)))*5.0
			projectiles[id].y=getplayery(0)+3+math.cos(math.rad(getplayerrotation(0)))*5.0
			-- Set speed of projectile
			math.randomseed(weapon_shots*12345*j)
			offset=-4-(weapon_timer/2)+math.random()*(8.0+weapon_timer)
			projectiles[id].sx=math.sin(math.rad(getplayerrotation(0)+offset))*20.0
			projectiles[id].sy=-math.cos(math.rad(getplayerrotation(0)+offset))*20.0
			projectiles[id].timer=0
			-- Initial movement
			projectiles[id].x=projectiles[id].x-projectiles[id].sx*1
			projectiles[id].y=projectiles[id].y-projectiles[id].sy*1
			for i=1,3,1 do
				if cc.hl2.Shotgun.bullet.move(id)==1 then
					break
				end
			end
		end
		-- Effects
		recoil(3)
		particle(p_muzzle,getplayerx(0)+(getplayerdirection(0)*7)+math.sin(math.rad(getplayerrotation(0)))*16,getplayery(0)+3-math.cos(math.rad(getplayerrotation(0)))*16)
		particle(p_smoke,getplayerx(0)+(getplayerdirection(0)*7)+math.sin(math.rad(getplayerrotation(0)))*16,getplayery(0)+3-math.cos(math.rad(getplayerrotation(0)))*16)
		particlespeed(-0.2+math.random()*0.4+getwind()*10.0,-1.0+math.random()*0.6)
		particlefadealpha(0.005)
		-- End Turn
		if (weapon_shots>=cc.hl2.Shotgun.ammo) then
			endturn()
		end
	end
end

--------------------------------------------------------------------------------
-- Projectile: Bullet
--------------------------------------------------------------------------------

cc.hl2.Shotgun.bullet.id=addprojectile("cc.hl2.Shotgun.bullet")		-- Add Projectile

function cc.hl2.Shotgun.bullet.draw(id)							-- Draw
	-- Setup draw mode
	setblend(blend_light)
	setalpha(1)
	setcolor(255,255,0)
	setscale(1,1)
	-- Calculate projectile rotation
	setrotation(math.deg(math.atan2(projectiles[id].sx,-projectiles[id].sy)))
	-- Draw projectile
	drawimage(cc.hl2.Shotgun.gfx_pro,projectiles[id].x,projectiles[id].y)
	-- Draw Arrow if out of Screen
	outofscreenarrow(projectiles[id].x,projectiles[id].y)
end

function cc.hl2.Shotgun.bullet.update(id)						-- Update
	-- Wind + Gravity influence on speed
	projectiles[id].sx=projectiles[id].sx+getwind()*0.01
	projectiles[id].sy=projectiles[id].sy+getgravity()*0.1
	-- Move
	cc.hl2.Shotgun.bullet.move(id)
end

function cc.hl2.Shotgun.bullet.move(id)
	-- Timer (free after 10 secs)
	projectiles[id].timer=projectiles[id].timer+1
	if projectiles[id].timer>500 then
		-- Free projectile
		freeprojectile(id)
		return 1
	end
	rot=math.deg(math.atan2(projectiles[id].sx,-projectiles[id].sy))
	-- Move (in substep loop for optimal collision precision)
	msubt=math.ceil(math.max(math.abs(projectiles[id].sx),math.abs(projectiles[id].sy))/3)
	msubx=projectiles[id].sx/msubt
	msuby=projectiles[id].sy/msubt
	for i=1,msubt,1 do
		projectiles[id].x=projectiles[id].x+msubx
		projectiles[id].y=projectiles[id].y+msuby		
		-- Collision
		if collision(col3x3,projectiles[id].x+math.sin(math.rad(rot))*20,projectiles[id].y-math.cos(math.rad(rot))*20,1,1)==1 then
			if terraincollision()==1 or playercollision()~=projectiles[id].ignore then
				-- Cause damage
				if playercollision()~=0 and playercollision()~=playercurrent() then
					playerpush(playercollision(),projectiles[id].sx/30.0,projectiles[id].sy/30.0)
					playerdamage(playercollision(),8)
					blood(projectiles[id].x+math.sin(math.rad(rot))*20,projectiles[id].y-math.cos(math.rad(rot))*20)
				end
				-- Destroy terrain
				for j=20,22,1 do
					terraincircle(projectiles[id].x+math.sin(math.rad(rot))*j,projectiles[id].y-math.cos(math.rad(rot))*j,3,0x00000000)
				end
				-- Effects
				playsound(sfx_ricochet1)
				particle(p_smoke,projectiles[id].x+math.sin(math.rad(rot))*21,projectiles[id].y-math.cos(math.rad(rot))*21)
				particlefadealpha(0.006)
				particle(p_muzzle,projectiles[id].x+math.sin(math.rad(rot))*21,projectiles[id].y-math.cos(math.rad(rot))*21)
				-- Free projectile
				freeprojectile(id)
				return 1
			end
		else
			projectiles[id].ignore=0
		end
		-- Water
		if (projectiles[id].y)>getwatery()+5 then
			-- Effects
			particle(p_waterhit,projectiles[id].x,projectiles[id].y)
			if math.random(1,2)==1 then
				playsound(sfx_hitwater2)
			else
				playsound(sfx_hitwater3)
			end
			-- Free projectile
			freeprojectile(id)
			return 1
		end
	end
end