--------------------------------------------------------------------------------
-- Weapon Stunbaton by Vectar666
-- Based on:
--
-- Weapon Pick
-- Original Carnage Contest Weapon
-- Script by DC, August 2009, www.UnrealSoftware.de
--------------------------------------------------------------------------------

-- Setup Tables
if cc==nil then cc={} end
if cc.hl2==nil then cc.hl2={} end
cc.hl2.stunbaton={}

-- Load & Prepare Ressources
cc.hl2.stunbaton.gfx_wpn=loadgfx("weapons/HL2_stunbaton.bmp")							-- Weapon Image
setmidhandle(cc.hl2.stunbaton.gfx_wpn)
cc.hl2.stunbaton.sfx_attack=loadsfx("swish.ogg")								-- Attack Sound
cc.hl2.stunbaton.sfx_hitground=loadsfx("HL2_stunstick_hitground.wav")
cc.hl2.stunbaton.sfx_hitbody=loadsfx("HL2_stunstick_hit.wav")						-- Hit Ground Sound

--------------------------------------------------------------------------------
-- Weapon: Pick
--------------------------------------------------------------------------------

cc.hl2.stunbaton.id=addweapon("cc.hl2.stunbaton","Stunstick",cc.hl2.stunbaton.gfx_wpn,2)				-- Add Weapon
cc.hl2.stunbaton.ammo=3														-- 2 hits

function cc.hl2.stunbaton.draw()												-- Draw
	-- Draw
	if getplayeraction(0)==0 then
		setblend(blend_alpha)
		setalpha(1)
		setcolor(255,255,255)
		setscale(-getplayerdirection(0),1)
		setrotation(getplayerrotation(0)-(30-(weapon_timer*3))*(getplayerdirection(0)))
		drawimage(cc.hl2.stunbaton.gfx_wpn,getplayerx(0)+getplayerdirection(0)*7,getplayery(0)+3)
	end
	-- HUD ammobar
	if cc.hl2.stunbaton.ammo-weapon_shots>0 then
		hudammobar(cc.hl2.stunbaton.ammo-weapon_shots,cc.hl2.stunbaton.ammo)
	end
	-- HUD Crosshair
	if cc.hl2.stunbaton.ammo-weapon_shots>0 then
		hudcrosshair(7,3)
	end
end

function cc.hl2.stunbaton.attack(attack)										-- Attack
	-- Timer
	if weapon_timer>0 then
		weapon_timer=weapon_timer-1
	end
	if (weapon_shots<cc.hl2.stunbaton.ammo) and (weapon_timer<=0) then
		if (attack==1) then
			-- No more weapon switching!
			useweapon(0)
			playsound(cc.hl2.stunbaton.sfx_attack)
			weapon_shots=weapon_shots+1
			weapon_timer=50
			-- Collision
			if collision(col20x20,getplayerx(0)+getplayerdirection(0)*21,getplayery(0),1,1)==1 then
				if playercollision()~=0 and playercollision()~=playercurrent() then
					playerpush(playercollision(),getplayerdirection(0)*2,-1)
					playerdamage(playercollision(),10)
					playerstate(playercollision(),state_confused,1)
					playsound(cc.hl2.stunbaton.sfx_hitbody)
				end
				if terraincollision()==1 then
					playsound(cc.hl2.stunbaton.sfx_hitground)
				end
			end
			-- Free Terrain
			grey=math.random(0,40)
			terrainalphaimage(gfx_crater25,getplayerx(0)+getplayerdirection(0)*7+math.sin(math.rad(getplayerrotation(0)))*1,getplayery(0)-1-math.cos(math.rad(getplayerrotation(0)))*3,math.random(6,9)*0.1,grey,grey,grey)
			terrainalphaimage(gfx_crater25,getplayerx(0)+getplayerdirection(0)*7+math.sin(math.rad(getplayerrotation(0)))*10,getplayery(0)-1-math.cos(math.rad(getplayerrotation(0)))*10,math.random(6,9)*0.1,grey,grey,grey)
			-- End Turn
			if weapon_shots>=cc.hl2.stunbaton.ammo then
				endturn()
			end
		end
	end
end
